/*
 * Rs[^bK 4-3: \̂ɂ镪̕\Ƃ֐ (|C^)
 * 2005N626        @
 * 2003N71        J ۔
 */

#include <stdio.h>
#include <stdlib.h>     /* abs()̂ */

/* \\̂fractionƂO */
typedef struct {
    int   n;    /* q (numerator) */
    int   d;    /*  (denominator) */
} fraction;

/* O̊֐̃vg^Cv錾 */
fraction fracMake(int n, int d);
void     fracPrint(fraction f);
fraction fracAdd(fraction f1, fraction f2);
fraction fracMul(fraction f1, fraction f2);
fraction fracReduce(fraction f);
int      gcd(int x, int y);

int
main(void)
{
    fraction    x1, x2, x3;

    /* x1, x2ɒlݒ */
    x1 = fracMake(3, 4);
    x2 = fracMake(5, -6);
    printf("x1 = "); fracPrint(x1); printf("\n");
    printf("x2 = "); fracPrint(x2); printf("\n");

    /* a̓mF */
    x3 = fracAdd(x1, x2);
    printf("x1 + x2 = "); fracPrint(x3); printf("\n");

    /* ς̓mF */
    x3 = fracMul(x1, x2);
    printf("x1 * x2 = "); fracPrint(x3); printf("\n");

    /* aƐς̍̓mF x3 = x1*x1 + x2*x2 */
    x3 = fracAdd(fracMul(x1, x1), fracMul(x2, x2));
    printf("x1*x1 + x2*x2 = "); fracPrint(x3); printf("\n");

    return 0;
}

/*
 * ̑no: n𕪎qCd𕪕Ƃfraction^߂lƂ
 */
fraction
fracMake(int n, int d)
{
    fraction  r;

    r.n = n;
    r.d = d;

    return r;
}

/*
 * ̕\: f\
 * ꂪ̏ꍇ̕\lĂȂD
 */
void
fracPrint(fraction f)
{
    printf("%d/%d", f.n, f.d);
}

/*
 * ̘a: f1f2̘a߂lƂ
 */
fraction
fracAdd(fraction f1, fraction f2)
{
    fraction r;

    r.n = f1.n*f2.d + f2.n*f1.d;
    r.d = f1.d*f2.d;

    return fracReduce(r);
}

/*
 * ̐: f1f2̐ς߂lƂ
 */
fraction
fracMul(fraction f1, fraction f2)
{
    fraction r;

    r.n = f1.n*f2.n;
    r.d = f1.d*f2.d;

    return fracReduce(r);
}

/*
 * ̖: f񕪂̂߂lƂ
 */
fraction
fracReduce(fraction f)
{
    fraction r;
    int      g;

    g = gcd(abs(f.n), abs(f.d));
    if ( f.d > 0 ) {
        r.n = f.n/g;
        r.d = f.d/g;
    } else {
        r.n = -f.n/g;
        r.d = -f.d/g;
    }

    return r;
}

/*
 * ő: xy̍ő񐔂߂lƂ
 */
int
gcd(int x, int y)
{
    int t;

    while ( y != 0 ) {
        t = x % y;
        x = y;
        y = t;
    }

    return x;
}
